#/bin/bash
dmpi=/usr/local/mpich2-1.4.1p1
export AMBERHOME=/home/mhviet/setup/amber14
export PATH=$PATH:${AMBERHOME}/bin:${dmpi}/bin
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${AMBERHOME}/lib:${dmpi}/lib
export CUDA_HOME=/usr/local/cuda
export PATH=$PATH:${CUDA_HOME}/bin
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${CUDA_HOME}/lib:${CUDA_HOME}/lib64

dirg=/home/mhviet/setup/G455/bin



dm=/home/mhviet/FFTEST
dpro=${dm}/PRO_FFTEST
dsa=${dm}/Adiff_AG
dres=${dm}/results_FFTEST
ff=ff12SB
dmw=${dm}/COMPARE${ff}_AG

c=1
ec=20
while [ ${c} -le ${ec} ] ; do
cd ${dmw}
sed -n ${c}p ${dm}/20aa_hb_bs_charge.dat | awk '{print  $1}' > vt.vt
read vt < vt.vt
rm ${dres}/dfGA_*_${vt}_${ff}.dat
dw=${dmw}/${vt}
mkdir ${dw}
cd ${dw}
wc -l ${dpro}/${vt}_100cfs.pdb | awk '{print $1/100}' > n1.vt
read n1 < n1.vt
t=1
et=100
while [ $t -le ${et} ] ; do
vts=${vt}_t${t}
let k1=(t-1)*n1+1
let k2=t*n1
sed -n ${k1},${k2}p ${dpro}/${vt}_100cfs.pdb > a.pdb
### energy in AMBER
cp ${AMBERHOME}/dat/leap/cmd/leaprc.ff12SB vprem_ff12SB.dat
echo ${vts}' = loadpdb "a.pdb"' >> vprem_ff12SB.dat
echo "saveamberparm ${vts} ${vts}_vac.prmtop ${vts}_vac.inpcrd" >> vprem_ff12SB.dat
echo 'list' >> vprem_ff12SB.dat
echo "quit" >> vprem_ff12SB.dat
tleap -s -f vprem_ff12SB.dat
echo "44.2002966  44.2002966  44.2002966 109.4712190 109.4712190 109.4712190" >> ${vts}_vac.inpcrd
pmemd -O -i ${dm}/min.in -o AB_${vts}.out -p ${vts}_vac.prmtop -c ${vts}_vac.inpcrd -r min1.rst -ref ${vts}_vac.inpcrd
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "BOND   =  " | awk '{print $3*4.184}' > bond.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "ANGLE   =" | awk '{print $6*4.184}' > angle.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "DIHED      =" | awk '{print $9*4.184}' > dihed.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "1-4 NB =" | awk '{print $4*4.184}' > 14vdW.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "1-4 NB =" | awk '{print $8*4.184}' > 14ele.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "1-4 NB =" | awk '{print $11*4.184}' > vdW.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "EELEC  =" | awk '{print $3*4.184}' > ele.AB
grep -A 5 "NSTEP =        0   TIME(PS) =       0.000  TEMP(K)" AB_${vts}.out | grep -h "EPtot      =" | awk '{print $9*4.184}' > Epot.AB

## energy in GROMACS
wc -l ${dsa}/dfAG_N${vt}.dat | awk '{print $1}' > mc.vt
read mc < mc.vt
cp a.pdb t.pdb
m=1
while [ $m -le ${mc} ] ; do
sed -n ${m}p ${dsa}/dfAG_N${vt}.dat | awk '{print $1}' > atA.vt
read atA < atA.vt
##sed -n ${m}p ${dsa}/dfAG_N${vt}.dat | awk '{print $2}' > atG.vt
##read atG < atG.vt
sed -e "s/ ${atA} / xx${m} /g" t.pdb > g.pdb
cp g.pdb t.pdb
let m=m+1
done
m=1
while [ $m -le ${mc} ] ; do
sed -n ${m}p ${dsa}/dfAG_N${vt}.dat | awk '{print $2}' > atG.vt
read atG < atG.vt
if [ $c -eq 19 ] && [ $m -ge 3 ] ; then
sed -e "s/ xx${m} /  ${atG} /g" t.pdb > g.pdb
else
sed -e "s/ xx${m} / ${atG} /g" t.pdb > g.pdb
fi
cp g.pdb t.pdb
let m=m+1
done
##if [ $c -eq 7 ] ; then
##sed -i "s/ HIE / HIS /g" t.pdb
##fi
${dirg}/pdb2gmx_s -f t.pdb -o t1.pdb -p t.top -ff amber12sb -water TIP3P
${dirg}/editconf_s -f t1.pdb -o t2.pdb -bt octahedron -d 1.2
mv t.top ${vts}.top
mv t2.pdb ${vts}.pdb
${dirg}/grompp_s  -f ${dm}/minGROMACS.mdp -p  ${vts}.top -c  ${vts}.pdb -o  ${vts}.tpr
${dirg}/mdrun_s -s ${vts}.tpr -g GR_${vts}.log
rm *#
grep -A 1 "Bond          Angle    Proper Dih.  Improper Dih.          LJ-14" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$1}' > bond.GR
grep -A 1 "Bond          Angle    Proper Dih.  Improper Dih.          LJ-14" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$2}' > angle.GR
grep -A 1 "Bond          Angle    Proper Dih.  Improper Dih.          LJ-14" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$3+$4}' > dihed.GR
grep -A 1 "Bond          Angle    Proper Dih.  Improper Dih.          LJ-14" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$5}' > 14vdW.GR
grep -A 1 "Coulomb-14        LJ (SR)   Coulomb (SR)      Potential Pressure (bar)" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$1}' > 14ele.GR
grep -A 1 "Coulomb-14        LJ (SR)   Coulomb (SR)      Potential Pressure (bar)" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$2}' > vdW.GR
grep -A 1 "Coulomb-14        LJ (SR)   Coulomb (SR)      Potential Pressure (bar)" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$3}' > ele.GR
grep -A 1 "Coulomb-14        LJ (SR)   Coulomb (SR)      Potential Pressure (bar)" GR_${vts}.log | tail -n 1 | awk '{printf "%.5f\n",$4}' > Epot.GR

paste bond.GR bond.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}'  >> ${dres}/dfGA_bond_${vt}_${ff}.dat
paste angle.GR angle.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_angle_${vt}_${ff}.dat
paste dihed.GR dihed.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_dihed_${vt}_${ff}.dat
paste 14vdW.GR 14vdW.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_14vdW_${vt}_${ff}.dat
paste 14ele.GR 14ele.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_14ele_${vt}_${ff}.dat
paste vdW.GR vdW.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_vdW_${vt}_${ff}.dat
paste ele.GR ele.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_ele_${vt}_${ff}.dat
paste Epot.GR Epot.AB | awk '{print 100*(($1-$2)**2/($1*$2))**0.5}' >> ${dres}/dfGA_Epot_${vt}_${ff}.dat
let t=t+1
done
let c=c+1
done
